<template>
  <div
    class="dont-miss-card"
    :style="`background-image: url(${backgroundImage});`"
  >
    <div class="dont-miss-card__content">
      <h3 class="dont-miss-card__title">{{ title }}</h3>
      <p class="dont-miss-card__text">
        <slot></slot>
      </p>
    </div>
    <div class="dont-miss-card__image-container">
      <img :src="personImage" />
    </div>
    <nuxt-link :to="url">
      <div class="dont-miss-card__bottom-container">
        <div class="dont-miss-card__bottom-bar">
          <span>{{ $t("play_now") }}</span>
        </div>
      </div>
    </nuxt-link>
  </div>
</template>

<script setup lang="ts">
defineProps({
  title: {
    type: String,
    required: false,
    default: "",
  },
  personImage: {
    type: String,
    required: false,
    default: "",
  },
  backgroundImage: {
    type: String,
    required: false,
    default: "",
  },
  url: {
    type: String,
    default: "",
  },
});
</script>
<style lang="scss">
:root {
  --dmc-max-width: 288px;
  --dmc-border-radius: 8px;
  --dmc-color: #0d69f2;
  --dmc-title-size: 150%;
  --dmc-font-size: 14px;
  --dmc-content-text-color: white;
  --dmc-content-gap: 16px;
  --dmc-content-padding: 16px;
  --dmc-transition-time: 0.4s;
}
</style>

<style scoped lang="scss">
@keyframes doAJump {
  0% {
    transform: translateY(10%) scaleY(0.7);
  }

  30% {
    transform: translateY(-10%) scaleY(1);
  }

  60% {
    transform: translateY(-7%) scaleY(1);
  }

  100% {
    transform: translateY(-7%) scaleY(1);
  }
}

:deep(.dont-miss-card::before),
:deep(.dont-miss-card::after),
:deep(.dont-miss-card *::before),
:deep(.dont-miss-card *::after) {
  --dmc-color: var(--dmc-color);
  --dmc-border-radius: var(--dmc-border-radius);
}
.dont-miss-card {
  aspect-ratio: 1.2;
  max-width: var(--dmc-max-width);
  width: 100%;
  border-radius: var(--dmc-border-radius);
  display: flex;
  flex-direction: column;
  align-items: center;
  position: relative;
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;
  border-radius: var(--dmc-border-radius);
}

.dont-miss-card::before {
  content: "";
  background-color: var(--dmc-color);
  opacity: 0.3;
  mix-blend-mode: overlay;
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;
  border-radius: var(--dmc-border-radius);
}

.dont-miss-card__content {
  width: 100%;
  height: 100%;
  display: flex;
  gap: var(--dmc-content-gap);
  flex-direction: column;
  align-items: center;
  justify-content: center;
  color: var(--dmc-content-text-color);
  padding: var(--dmc-content-padding);
  overflow: hidden;
}

.dont-miss-card__content::before {
  content: "";
  position: absolute;
  width: 100%;
  height: 100%;
  background: #000;
  opacity: 0.7;
  border-radius: var(--dmc-border-radius);
  transition: opacity 0.4s;
}

.dont-miss-card__title {
  font-size: var(--dmc-title-size);
  line-height: 28px;
  transform: translateY(0);
  text-align: center;
  font-weight: 900;
  color: var(--dmc-color);
  transition: opacity 0.4s, transform 0.4s;
}

.dont-miss-card__text :deep() {
  color: inherit;
  z-index: 1;
  transition: opacity 0.4s, transform 0.4s;
  line-height: 18px;
  text-align: center;
}

.dont-miss-card__text :deep() * {
  color: inherit;
  font-weight: 400;
  font-size: var(--dmc-font-size);
  line-height: var(--dmc-title-size);
}

.dont-miss-card__image-container {
  position: absolute;
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  z-index: 1;
}

.dont-miss-card__image-container img {
  max-width: var(--dmc-max-width);
  width: 100%;
  opacity: 0;
  visibility: hidden;
  transition: all 0.5s;
  transform: translateY(-7%);
}

.dont-miss-card__bottom-container {
  width: 100%;
  height: 20%;
  overflow: hidden;
  position: absolute;
  left: 0;
  bottom: 0;
  border-bottom-left-radius: var(--dmc-border-radius);
  border-bottom-right-radius: var(--dmc-border-radius);
  z-index: 2;
}

.dont-miss-card__bottom-bar {
  position: relative;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  cursor: pointer;
  transform: translateY(72%);
  transition: transform 0.3s;
}

.dont-miss-card__bottom-bar::before,
.dont-miss-card__bottom-bar::after {
  transition: background 0.5s;
  content: "";
  position: absolute;
}

:deep(.dont-miss-card__bottom-bar::before) {
  background: var(--dmc-color);
  height: 87%;
  left: 0;
  bottom: 0;
  width: 100%;
}

:deep(.dont-miss-card__bottom-bar::after) {
  background: var(--dmc-color);
  width: 40%;
  height: 14%;
  left: 50%;
  top: 0;
  border-top-left-radius: 16px;
  border-top-right-radius: 16px;
  transform: translateX(-50%) translateY(5%);
}

.dont-miss-card__bottom-bar span {
  color: var(--dmc-color);
  font-weight: 800;
  font-size: var(--dmc-title-size);
  z-index: 1;
  position: relative;
  text-align: center;
  white-space: nowrap;
  user-select: none;
}

.dont-miss-card:hover .dont-miss-card__bottom-bar,
.dont-miss-card:focus .dont-miss-card__bottom-bar {
  transform: translateY(0);
}
.dont-miss-card:hover .dont-miss-card__bottom-bar span,
.dont-miss-card:focus .dont-miss-card__bottom-bar span {
  color: black;
  padding-top: 5px;
}

.dont-miss-card:hover .dont-miss-card__content::before,
.dont-miss-card:focus .dont-miss-card__content::before {
  opacity: 0;
}

.dont-miss-card:hover .dont-miss-card__title,
.dont-miss-card:focus .dont-miss-card__title,
.dont-miss-card:hover .dont-miss-card__text,
.dont-miss-card:focus .dont-miss-card__text {
  transform: translateY(50%);
  opacity: 0;
}

.dont-miss-card:hover .dont-miss-card__image-container img,
.dont-miss-card:focus .dont-miss-card__image-container img {
  opacity: 1;
  visibility: visible;
  animation: doAJump 1s ease-in-out forwards;
  animation-iteration-count: 1;
}
</style>
